/*
 * 开发人员：新生帝(JsonLei)
 * 设计理念：只为了更懒和那份不可替代性！
 */

// 服务器地址
//development-env
window.serverUrl = "http://192.168.31.114:8080/";
//test-env
window.serverUrl = "http://open.lingyunxinli.cn/entdiy/";
//product-env
window.serverUrl = "https://open.lingyunxinli.com/entdiy/";

//window.uploadUrl = "http://192.168.31.113:8080/";

// AC默认参数 BEGIN

window.openWinAnimationType = "movein";
window.openWinAnimationSubType = "from_right";
window.openWinAnimationDuration = 300;
window.openWinDelay = 300;
window.toastDuration = 4000;
window.toastLocation = "bottom";
window.showProgressAnimationType = "fade";
window.showProgressTitle = "努力加载中...";
window.showProgressText = "先喝杯茶...";
window.ajaxTimeout = 10000;
window.infotitle = "系统提示";
// APP默认参数 END
// 用户偏好设置的Key
window.userKey = "user";
window.welcomeKey = "welcomeShow";
// 继承拓展对象
window.success = "success";
window.failure = "failure";

window.agoraAppId = '8e96b034a7a84db59c3f2b95e2222838';

window.defaultAlertDialogStyle = {
    bg: '#fff',
    corner: 10,
    w: 300,
    title: {
        marginT: 24,
        icon: '',
        iconSize: 40,
        titleSize: 18,
        titleColor: 'rgb(51,51,51)'
    },
    content: {
        marginT: 14,
        color: 'rgb(102,102,102)',
        size: 14
    },
    left: {
        marginB: 24,
        marginL: 24,
        w: 115,
        h: 40,
        corner: 20,
        color: 'rgb(51,51,51)',
        bg: 'rgb(208,219,218)',
        size: 16
    },
    right: {
        marginB: 24,
        marginL: 22,
        w: 115,
        h: 40,
        corner: 20,
        color: 'rgb(255,255,255)',
        bg: 'rgb(22,210,194)',
        size: 16
    }
}

function _extents(obj1, obj2) {
    for (var i in obj2) {
        if (obj1[i]) {
            continue;
        } else {
            obj1[i] = obj2[i];
        }
    }
}

// 手机号验证
function _checkPhone(phone) {
    var res = !!phone.match(/^(0|86|17951)?(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/);
    return res;
}

// 打开新窗口
function _openWin(name, url, pageParam, bgColor, animateDirection, bounces, reload) {
    var _pageParam = (typeof arguments[2] == "undefined" || arguments[2] == null) ? api.pageParam : arguments[2];
    var _bgColor = (typeof arguments[3] == "undefined" || arguments[3] == null) ? 'rgba(0,0,0,0)' : arguments[3];
    var _animateDirection = (typeof arguments[4] == "undefined" || arguments[4] == null) ? window.openWinAnimationSubType : arguments[4];
    var _bounces = (typeof arguments[5] == "undefined" || arguments[5] == null) ? false : arguments[5];
    var _reload = (typeof arguments[6] == "undefined" || arguments[6] == null) ? true : arguments[6];
    api.openWin({
        name: name,
        url: url,
        pageParam: _pageParam,
        bgColor: _bgColor,
        bounces: _bounces,
        scrollToTop: true,
        slidBackEnabled: false,
        animation: {
            type: window.openWinAnimationType,
            subType: _animateDirection,
            duration: window.openWinAnimationDuration
        },
        delay: api.systemType == "ios" ? 0 : window.openWinDelay,
        reload: _reload,
        allowEdit: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false
    });
}

// 打开新框架
function _openFrame(name, url, rect, pageParam, bgColor, bounces, reload, showProgress) {
    var __rect = {
        x: 0,
        y: 0,
        w: api.winWidth,
        y: api.winHeight,
        l: 0,
        t: 0,
        b: 0,
        r: 0
    };
    var _rect = (typeof arguments[2] == "undefined" || arguments[2] == null || typeof arguments[2] != "object") ? __rect : arguments[2];
    var _pageParam = (typeof arguments[3] == "undefined" || arguments[3] == null) ? api.pageParam : arguments[3];
    var _bgColor = (typeof arguments[4] == "undefined" || arguments[4] == null) ? 'rgba(0,0,0,0)' : arguments[4];
    var _bounces = (typeof arguments[5] == "undefined" || arguments[5] == null) ? false : arguments[5];
    var _reload = (typeof arguments[6] == "undefined" || arguments[6] == null) ? false : arguments[6];
    var _showProgress = (typeof arguments[7] == "undefined" || arguments[7] == null) ? false : arguments[7];
    api.openFrame({
        name: name,
        url: url,
        rect: {
            x: typeof _rect.x != "number" ? __rect.x : _rect.x,
            y: typeof _rect.y != "number" ? __rect.y : _rect.y,
            w: typeof _rect.w != "number" ? __rect.w : _rect.w,
            h: typeof _rect.h != "number" ? __rect.h : _rect.h,
            marginLeft: typeof _rect.l != "number" ? __rect.l : _rect.l,
            marginTop: typeof _rect.t != "number" ? __rect.t : _rect.t,
            marginBottom: typeof _rect.b != "number" ? __rect.b : _rect.b,
            marginRight: typeof _rect.r != "number" ? __rect.r : _rect.r
        },
        bgColor: _bgColor,
        pageParam: _pageParam,
        scrollToTop: true,
        bounces: _bounces,
        showProgress: _showProgress,
        reload: _reload,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        allowEdit: true
    });
}

// 关闭当前窗口到新的窗口
function _closeToWin(name) {
    api.closeToWin({
        name: name,
        animation: {
            type: 'movein',
            subType: 'from_left',
            duration: 300
        }
    });
}

// 小提示
function _toast(msg, duration, location, _call) {
    var _duration = (typeof arguments[1] == "undefined" || arguments[1] == null) ? window.toastDuration : arguments[1];
    var _location = (typeof arguments[2] == "undefined" || arguments[2] == null) ? window.toastLocation : arguments[2];
    api.toast({
        msg: msg,
        duration: _duration,
        location: _location
    });
    if (typeof _call == "function") {
        setTimeout(_call, duration);
    }
}

// 加载框
function _showProgress(title, text, modal, animationType) {
    var _title = (typeof arguments[0] == "undefined" || arguments[0] == null) ? window.showProgressTitle : arguments[0];
    var _text = (typeof arguments[1] == "undefined" || arguments[1] == null) ? window.showProgressText : arguments[1];
    var _modal = (typeof arguments[2] == "undefined" || arguments[2] == null) ? true : arguments[2];
    var _animationType = (typeof arguments[3] == "undefined" || arguments[3] == null) ? window.showProgressAnimationType : arguments[3];
    api.showProgress({
        style: 'default',
        animationType: _animationType,
        title: _title,
        text: _text,
        modal: _modal
    });
}

// 双击退出应用
function _twoClickCloseApp(_call) {
    //定义个时间戳
    var mkeyTime = new Date().getTime();

    _addEventListener('keyback', function(ret) {
        //如果当前时间减去标志时间大于2秒，说明是第一次点击返回键，反之为2秒内点了2次，则退出。
        if ((new Date().getTime() - mkeyTime) > 2000) {
            mkeyTime = new Date().getTime();
            _toast('再按一次退出程序', 2000);
        } else {
            if (typeof _call == "function") {
                _call();
            }
            // 静默关闭,不弹出关闭提示窗口
            api.closeWidget({
                silent: true
            });
        }
    }, {});
}

// 下拉刷新
function _setRefreshHeaderInfo(_call, bgColor, textColor) {
    var _bgColor = (typeof arguments[1] == "undefined" || arguments[1] == null) ? '#F9F9F9' : arguments[1];
    var _textColor = (typeof arguments[2] == "undefined" || arguments[2] == null) ? '#999' : arguments[2];
    api.setRefreshHeaderInfo({
        visible: true,
        loadingImg: 'widget://image/refresh.png',
        bgColor: _bgColor,
        textColor: _textColor,
        textDown: '下拉刷新...',
        textUp: '松开刷新...',
        showTime: true
    }, function(ret, err) {
        if (typeof _call == "function") {
            _call();
        }
    });
}

// 上拉加载
function _scrolltobottom(_call, threshold) {
    var _threshold = (typeof arguments[1] == "undefined" || arguments[1] == null) ? 0 : arguments[1];
    _addEventListener('scrolltobottom', _call, {
        threshold: _threshold
    });
}

// 获取偏好设置
function _getPrefs(key, _call) {
    api.getPrefs({
        key: key
    }, function(ret, err) {
        var v = ret.value;
        if (typeof _call == "function") {
            _call(v);
        }
    });
}

// 设置偏好设置
function _setPrefs(key, value, _call) {
    api.setPrefs({
        key: key,
        value: value
    }, function(ret, err) {
        var v = ret.value;
        if (typeof _call == "function") {
            _call();
        }
    });
}

// 移除偏好设置
function _removePrefs(key, _call) {
    api.removePrefs({
        key: key
    }, function(ret, err) {
        var v = ret.value;
        if (typeof _call == "function") {
            _call();
        }
    });
}

// 设置存储
function _setStorage(key, value) {
    $api.setStorage(key, value);
}

// 获取存储
function _getStorage(key) {
    return $api.getStorage(key);
}

// 移除存储
function _removeStorage(key) {
    return $api.rmStorage(key);
}

// // 异步请求
// function _ajax(url, method, data, dataType, _call, headers, cache, timeout, tag) {
//     var _data = (typeof arguments[2] == "undefined" || arguments[2] == null) ? {} : arguments[2];
//     var _dataType = (typeof arguments[3] == "undefined" || arguments[3] == null) ? "json" : arguments[3];
//     var _headers = (typeof arguments[5] == "undefined" || arguments[5] == null) ? {} : arguments[5];
//     var _cache = (typeof arguments[6] == "undefined" || arguments[6] == null) ? false : arguments[6];
//     var _timeout = (typeof arguments[7] == "undefined" || arguments[7] == null) ? window.ajaxTimeout : arguments[7];
//     var _tag = (typeof arguments[8] == "undefined" || arguments[8] == null) ? '' : arguments[8];
//     api.ajax({
//         url: url,
//         cache: _cache,
//         tag: _tag,
//         method: method,
//         headers: _headers,
//         timeout: _timeout,
//         dataType: _dataType,
//         returnAll: false,
//         data: _data
//     }, function(ret, err) {
//         if (ret) {
//             if (typeof _call == "function") {
//                 _call(ret);
//             }
//         } else {
//             api.hideProgress();
//             api.refreshHeaderLoadDone();
//             _toast("亲，网速不给力哦~");
//             api.alert({
//                 msg: ('错误码：' + err.code + '；错误信息：' + err.msg + '网络状态码：' + err.statusCode)
//             });
//         }
//
//     });
// }

// 解决状态栏重合
function _fixStatusBar(headerid, callback) {
    var header = $api.byId(headerid);
    var systemType = api.systemType;
    var systemVersion = parseFloat(api.systemVersion);
    if (systemType == "ios" || (systemType == "android" && systemVersion >= 4.4)) {
        if (systemType == "android") {
            header.style.paddingTop = '25px';
        }
        $api.fixStatusBar(header);
    } else {
        $api.fixIos7Bar(header);
    }
    var headerPos = $api.offset(header);
    if (typeof callback == "function") {
        callback(headerPos);
    }
}

// 指定window或者frame执行脚本
function _execScript(winName, frmName, fnStr) {
    var _winName = (typeof arguments[0] == "undefined" || arguments[0] == null) ? api.winName : arguments[0];
    var _frmName = (typeof arguments[1] == "undefined" || arguments[1] == null) ? api.frameName : arguments[1];
    var _fnStr = (typeof arguments[2] == "undefined" || arguments[2] == null) ? '' : arguments[2];
    api.execScript({
        name: _winName,
        frameName: _frmName,
        script: _fnStr
    });
}

// 广播事件
function _sendEvent(eventName, extra) {
    var _extra = (typeof arguments[1] == "undefined" || arguments[1] == null) ? {} : arguments[1];
    api.sendEvent({
        name: eventName,
        extra: _extra
    });
}

// 监听事件
function _addEventListener(eventName, _call, extra) {
    var _extra = (typeof arguments[2] == "undefined" || arguments[2] == null) ? {} : arguments[2];
    api.addEventListener({
        name: eventName,
        extra: _extra
    }, function(ret, err) {
        if (typeof _call == "function") {
            _call(ret);
        }
    });
}

// 打开相册或相机
//library            //图片库
//camera            //相机
//album            //相册
//pic            //图片
//video        //视频
function _getPicture(_call, encodingType, mediaValue, destinationType, quality, targetWidth, targetHeight, saveToPhotoAlbum, allowEdit) {
    var _encodingType = (typeof arguments[1] == "undefined" || arguments[1] == null) ? "jpg" : arguments[1];
    var _mediaValue = (typeof arguments[2] == "undefined" || arguments[2] == null) ? "pic" : arguments[2];
    var _destinationType = (typeof arguments[3] == "undefined" || arguments[3] == null) ? "url" : arguments[3];
    var _quality = (typeof arguments[4] == "undefined" || arguments[4] == null) ? 50 : arguments[4];
    var _targetWidth = (typeof arguments[5] == "undefined" || arguments[5] == null) ? 320 : arguments[5];
    var _targetHeight = (typeof arguments[6] == "undefined" || arguments[6] == null) ? 320 : arguments[6];
    var _saveToPhotoAlbum = (typeof arguments[7] == "undefined" || arguments[7] == null) ? true : arguments[7];

    api.actionSheet({
        title: '您想要从哪里选取图片？',
        cancelTitle: '取消',
        buttons: ["优雅自拍", "相册收藏"]
    }, function(ret, err) {
        if (ret.buttonIndex == 3) {
            return;
        }
        var sourceType = "album";
        if (ret.buttonIndex == 1) {
            sourceType = "camera";
        }

        api.getPicture({
            sourceType: sourceType,
            encodingType: _encodingType,
            destinationType: _destinationType,
            mediaValue: _mediaValue,
            quality: _quality,
            targetWidth: _targetWidth,
            targetHeight: _targetHeight,
            saveToPhotoAlbum: _saveToPhotoAlbum
        }, function(ret, err) {
            if (ret) {
                if (typeof _call == "function") {
                    _call(ret.data);
                }
            } else {
                api.alert({
                    msg: err.msg
                });
            }
        });
    });

}

// 判断是否是IOS
function _isIOS() {
    return api.systemType == "ios" ? true : false;
}

// 滚动到底部
function _scrollToEnd() {
    document.getElementsByTagName('body')[0].scrollTop = document.getElementsByTagName('body')[0].scrollHeight;
    if (_isIOS()) {
        //1、ios
        var systemVersion = api.systemVersion;
        if (parseInt(systemVersion.substring(0, 2)) > 12) {
            document.documentElement.scrollTop = document.documentElement.scrollHeight;
        }
    }
}

// 设置frame显示隐藏状态
function _setFrameStatus(name, isHidden) {
    api.setFrameAttr({
        name: name,
        hidden: isHidden
    });
}

// 判断是否是正整数
function _isNumber(str) {
    var re = /^[0-9]*[1-9][0-9]*$/;
    return re.test(str)
}

// 是否是正浮点数
function _isDecimal(str) {
    var re = /^(([0-9]|([1-9][0-9]{0,9}))((\.[0-9]{1,2})?))$/;
    return re.test(str)
}

// 是否是日期格式
function _isDate(str) {
    var re = /^(?:(?:1[6-9]|[2-9][0-9])[0-9]{2}([-/.]?)(?:(?:0?[1-9]|1[0-2])\1(?:0?[1-9]|1[0-9]|2[0-8])|(?:0?[13-9]|1[0-2])\1(?:29|30)|(?:0?[13578]|1[02])\1(?:31))|(?:(?:1[6-9]|[2-9][0-9])(?:0[48]|[2468][048]|[13579][26])|(?:16|[2468][048]|[3579][26])00)([-/.]?)0?2\2(?:29))(\s+([01][0-9]:|2[0-3]:)?[0-5][0-9]:[0-5][0-9])?$/;
    return re.test(str)
}

// 清除缓存
function _clearCache() {
    api.clearCache(function(ret, err) {
        _toast("清除成功");
    });
}

// 退出登录
function _loginOut(_call) {
    _removePrefs(window.userKey, _call);
}

// 禁止返回
function _stopBack(_call) {
    _addEventListener('keyback', function(ret) {
        if (typeof _call == "function") {
            _call(ret.data);
        }
    }, {});
}

// 弹窗
function _alert(obj) {
    if (typeof obj == "object") {
        api.alert({
            msg: JSON.stringify(obj)
        }, function(ret, err) {

        });
    } else {
        api.alert({
            msg: obj
        }, function(ret, err) {

        });
    }
}

function _infoCall(title, content, _call) {
    var dialogBox = api.require('dialogBox');
    //先关闭前面的窗口
    dialogBox.close({
        dialogName: 'alert'
    });
    dialogBox.alert({
        texts: {
            title: title,
            content: content,
            rightBtnTitle: '确定'
        },
        styles: {
            bg: '#fff',
            corner: 4,
            w: 300,
            title: {
                marginT: 32,
                titleSize: 18,
                titleColor: 'rgb(51,51,51)'
            },
            content: {
                marginT: 20,
                color: 'rgb(102,102,102)',
                size: 14
            },
            right: {
                marginB: 32,
                marginL: 30,
                w: 240,
                h: 40,
                corner: 20,
                color: 'rgb(255,255,255)',
                bg: 'rgb(22,210,194)',
                size: 16
            }
        }
    }, function(ret) {
        var dialogBox = api.require('dialogBox');
        dialogBox.close({
            dialogName: 'alert'
        });
        if (typeof _call == "function") {
            _call();
        }
    });
}

function _info(obj) {
    var dialogBox = api.require('dialogBox');
    var msg = "";
    if (typeof obj == "object") {
        msg = JSON.stringify(obj);
    } else {
        msg = obj;
    }
    dialogBox.alert({
        texts: {
            title: window.infotitle,
            content: msg,
            rightBtnTitle: '确定'
        },
        styles: {
            bg: '#fff',
            corner: 4,
            w: 300,
            title: {
                marginT: 32,
                titleSize: 18,
                titleColor: 'rgb(51,51,51)'
            },
            content: {
                marginT: 20,
                color: 'rgb(102,102,102)',
                size: 14
            },
            right: {
                marginB: 32,
                marginL: 30,
                w: 240,
                h: 40,
                corner: 20,
                color: 'rgb(255,255,255)',
                bg: 'rgb(22,210,194)',
                size: 16
            }
        }
    }, function(ret) {
        var dialogBox = api.require('dialogBox');
        dialogBox.close({
            dialogName: 'alert'
        });
    });
}

// 根据出生日期算年龄
function ages(str) {
    var r = str.match(/^(\d{1,4})(-|\/)(\d{1,2})\2(\d{1,2})$/);
    if (r == null)
        return false;
    var d = new Date(r[1], r[3] - 1, r[4]);
    if (d.getFullYear() == r[1] && (d.getMonth() + 1) == r[3] && d.getDate() == r[4]) {
        var Y = new Date().getFullYear();
        return (Y - r[1]);
    }
    return 0;
}

function _imageCache(url) {
    var path = url;
    api.imageCache({
        url: url,
    }, function(ret, err) {
        if (ret) {
            path = ret.url;
        }
    });
    return path;
}

// 获取文件拓展名
function _getExt(fileName) {
    return fileName.substring(fileName.lastIndexOf('.') + 1);
}

// PHP时间戳转时间
function _trans_php_time_to_str(timestamp, n) {
    update = new Date(timestamp * 1000);
    //时间戳要乘1000
    year = update.getFullYear();
    month = (update.getMonth() + 1 < 10) ? ('0' + (update.getMonth() + 1)) : (update.getMonth() + 1);
    day = (update.getDate() < 10) ? ('0' + update.getDate()) : (update.getDate());
    hour = (update.getHours() < 10) ? ('0' + update.getHours()) : (update.getHours());
    minute = (update.getMinutes() < 10) ? ('0' + update.getMinutes()) : (update.getMinutes());
    second = (update.getSeconds() < 10) ? ('0' + update.getSeconds()) : (update.getSeconds());
    if (n == 1) {
        return (year + '-' + month + '-' + day + ' ' + hour + ':' + minute + ':' + second);
    } else if (n == 2) {
        return (year + '-' + month + '-' + day);
    } else {
        return 0;
    }
}

// 生成guid,主要用于生成随机文件名
function _newGuid() {
    function S4() {
        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
    }

    return (S4() + S4() + "-" + S4() + "-" + S4() + "-" + S4() + "-" + S4() + S4() + S4());
}

// 获取当前的时间，拼接成2015-11-09这样的格式，主要用于对图片进行时间分类
function _getNowFormatDate() {
    var date = new Date();
    var seperator1 = "-";
    var year = date.getFullYear();
    var month = date.getMonth() + 1;
    var strDate = date.getDate();
    if (month >= 1 && month <= 9) {
        month = "0" + month;
    }
    if (strDate >= 0 && strDate <= 9) {
        strDate = "0" + strDate;
    }
    var currentdate = year + seperator1 + month + seperator1 + strDate
    return currentdate;
}

function _getWeekday() {
    var d = new Date()
    var weekday = new Array(7)
    weekday[0] = "星期天"
    weekday[1] = "星期一"
    weekday[2] = "星期二"
    weekday[3] = "星期三"
    weekday[4] = "星期四"
    weekday[5] = "星期五"
    weekday[6] = "星期六"
    return weekday[d.getDay()];
}

function _getWeekname(d) {
    var weekday = new Array(7)
    weekday[0] = "周日"
    weekday[1] = "周一"
    weekday[2] = "周二"
    weekday[3] = "周三"
    weekday[4] = "周四"
    weekday[5] = "周五"
    weekday[6] = "周六"
    return weekday[d.getDay()];
}

function _getTomorrow(d) {
    var weekday = new Array(7)
    weekday[0] = "周日"
    weekday[1] = "周一"
    weekday[2] = "周二"
    weekday[3] = "周三"
    weekday[4] = "周四"
    weekday[5] = "周五"
    weekday[6] = "周六"

    var today = new Date();
    var w1 = today.getDay();
    var w2 = d.getDay();
    var w = w2 - w1;
    if (w < 0) w = w + 7;
    if (w == 0) {
        return '今天';
    } else if (w == 1) {
        return '明天';
    } else if (w == 2) {
        return '后天';
    }
    return weekday[d.getDay()];
}

// 图片压缩
// imageFilter:压缩对象
// imgsrc：源图片的路径
// quality：图片压缩质量，一般建议0.5
// scale：图片压缩比例，也是建议0.5
// ext：源图片拓展名
// callback：转换成功之后回调函数
function _imgCompress(imageFilter, imgsrc, quality, scale, ext, callback) {
    // 压缩文件的保存目录
    var savePath = api.cacheDir + "/" + _getNowFormatDate() + "/";
    // 压缩文件生成的随机文件名称
    var savename = _newGuid() + "." + ext;
    imageFilter.compress({
        img: imgsrc,
        quality: quality,
        scale: quality,
        save: {
            album: false,
            imgPath: savePath,
            imgName: savename
        }
    }, function(ret, err) {
        if (ret) {
            callback(savePath + savename);
        } else {
            alert(JSON.stringify(err));
        }
    });
}

// 上传图片
function _uploadImgs(data, _call) {
    _toast("上传中...", 10000);
    _ajax("api/pub/file-upload/kind-editor", "post", {
        files: {
            "imgFile": data
        }
    }, "json", function(ret) {
        if (ret.statu == 1) {
            _toast("上传成功!");
            if (typeof _call == "function") {
                _call(ret);
            }
        } else if (ret.statu == 0) {
            _toast("系统繁忙，请重新上传!");
        } else {
            _toast("非法参数!");
        }
    });
}

// // 时间戳转时间
// function _formatDate(timespan) {
//     var now = new Date(timespan);
//     var year = now.getFullYear();
//     var month = now.getMonth() + 1;
//     var date = now.getDate();
//     var hour = now.getHours();
//     var minute = now.getMinutes();
//     var second = now.getSeconds();
//     return year + "-" + month + "-" + date + "   " + hour + ":" + minute + ":" + second;
// }

function _formatDate(timespan) {
    var now = new Date(timespan);
    var year = now.getFullYear();
    var month = now.getMonth() + 1;
    var date = now.getDate();
    var hour = now.getHours();
    var minute = now.getMinutes();
    var second = now.getSeconds();
    //year + "-" +
    // + ":" + (second < 10 ? '0' + second : second)
    // (month < 10 ? '0' + month : month) + "-" + (date < 10 ? '0' + date : date) + " " +
    return year + "-" + (month < 10 ? '0' + month : month) + "-" + (date < 10 ? '0' + date : date) + " " + (hour < 10 ? '0' + hour : hour) + ":" + (minute < 10 ? '0' + minute : minute) + ":" + (second < 10 ? '0' + second : second);
}

function _formatDateShort(timespan) {
    var now = new Date(timespan);
    var year = now.getFullYear();
    var month = now.getMonth() + 1;
    var date = now.getDate();
    var hour = now.getHours();
    var minute = now.getMinutes();
    var second = now.getSeconds();
    return (month < 10 ? '0' + month : month) + "-" + (date < 10 ? '0' + date : date) + " " + (hour < 10 ? '0' + hour : hour) + ":" + (minute < 10 ? '0' + minute : minute);
}

function _formatDate2(timespan) {
    var now = new Date(timespan);
    var year = now.getFullYear();
    var month = now.getMonth() + 1;
    var date = now.getDate();
    var hour = now.getHours();
    var minute = now.getMinutes();
    var second = now.getSeconds();
    return (month < 10 ? '0' + month : month) + "-" + (date < 10 ? '0' + date : date) + " " + (hour < 10 ? '0' + hour : hour) + ":" + (minute < 10 ? '0' + minute : minute) + ":" + (second < 10 ? '0' + second : second);
}

function _formatStrDateShort(str) {
    var now = _convertDate(str);
    var year = now.getFullYear();
    var month = now.getMonth() + 1;
    var date = now.getDate();
    var hour = now.getHours();
    var minute = now.getMinutes();
    var second = now.getSeconds();
    return (month < 10 ? '0' + month : month) + "-" + (date < 10 ? '0' + date : date) + " " + (hour < 10 ? '0' + hour : hour) + ":" + (minute < 10 ? '0' + minute : minute);
}

function _formatStrDateShortEnd(str) {
    var now = _convertDate(str);
    var year = now.getFullYear();
    var month = now.getMonth() + 1;
    var date = now.getDate();
    var hour = now.getHours();
    var minute = now.getMinutes();
    var second = now.getSeconds();
    return (hour < 10 ? '0' + hour : hour) + ":" + (minute < 10 ? '0' + minute : minute);
}

function _formatTimeShort(str) {
    var now = _convertDate(str);
    var year = now.getFullYear();
    var month = now.getMonth() + 1;
    var date = now.getDate();
    var hour = now.getHours();
    var minute = now.getMinutes();
    var second = now.getSeconds();
    return (hour < 10 ? '0' + hour : hour) + ":" + (minute < 10 ? '0' + minute : minute);
}

function _getDateStr(datetimeStr) {
    if (datetimeStr) {
        var t = datetimeStr.split(' ');
        if (t.length > 0) {
            return t[0];
        }
    }
    return '';
}

function _getTimeStr(datetimeStr) {
    if (datetimeStr) {
        var t = datetimeStr.split(' ');
        if (t.length > 1) {
            return t[1];
        }
    }
    return '';
}

function _convertDate(s) {
    //var s ='2017-04-18 09:16:15';
    s = s.replace(/-/g, "/");
    return new Date(s);
}

function _getTargetday(num) {
    var number = null;
    if (num == null || num == 0) {
        number = 0;
    } else {
        number = num;
    }
    var today = new Date();
    var targetday_milliseconds = today.getTime() + 1000 * 60 * 60 * 24 * number;
    var targetday = new Date();
    targetday.setTime(targetday_milliseconds); //注意，这行是关键代码
    return targetday;
}

// 去除数组重复项
function _unique(arr) {
    var result = [],
        hash = {};
    for (var i = 0, elem;
        (elem = arr[i]) != null; i++) {
        if (!hash[elem]) {
            result.push(elem);
            hash[elem] = true;
        }
    }
    return result;
}

function _log(obj) {
    if (api.debug) {
        if (typeof obj == "object") {
            console.log(JSON.stringify(obj));
        } else {
            console.log(obj);
        }
    }
}

function _getUser() {
    return $api.getStorage(window.userKey);
}

function _getWelcome() {
    return $api.getStorage(window.welcomeKey);
}

function _get(url, data, _callback, _error) {
    var user = _getUser();
    var header = {
        'X-Requested-With': 'XMLHttpRequest'
    }
    if (user && user.access_token) {
        header = {
            'X-Requested-With': 'XMLHttpRequest',
            'ACCESS-TOKEN': user.access_token
        }
    }
    _ajax(url, 'get', header, data, _callback, _error);
}

function _post(url, data, _callback, _error) {
    var user = _getUser();

    var header = {
        'X-Requested-With': 'XMLHttpRequest'
    }
    if (user && user.access_token) {
        header = {
            'X-Requested-With': 'XMLHttpRequest',
            'ACCESS-TOKEN': user.access_token
        }
    }
    _ajax(url, 'post', header, data, _callback, _error);
}


function _ajax(url, type, headers, data, _callback, _error) {
    $.ajax({
        url: window.serverUrl + url,
        type: type,
        headers: headers,
        data: data,
        async: true,
        timeout: window.ajaxTimeout,
        beforeSend: function(xhr, settings) {
            _loading();
        },
        complete: function(xhr, status) {
            api.hideProgress();
            api.refreshHeaderLoadDone();
        },
        success: function(result, status, xhr) {
            if (typeof _callback == "function") {
                _callback(result);
            }
        },
        error: function(xhr, errorType, error) {
            if (_error && typeof _error == "function") {
                _error(errorType);
            } else {
                api.toast({
                    msg: '网络连接失败，请检查！'
                });
            }
            //TODO 如果是401，则记录这次访问的连接，然后弹出提示框跳转登录
        }
    });
}

function _getNoLoading(url, data, _callback, _error) {
    var user = _getUser();
    var header = {
        'X-Requested-With': 'XMLHttpRequest'
    }
    if (user && user.access_token) {
        header = {
            'X-Requested-With': 'XMLHttpRequest',
            'ACCESS-TOKEN': user.access_token
        }
    }
    _ajaxNoLoading(url, 'get', header, data, _callback, _error);
}

function _postNoLoading(url, data, _callback, _error) {
    var user = _getUser();
    var header = {
        'X-Requested-With': 'XMLHttpRequest'
    }
    if (user && user.access_token) {
        header = {
            'X-Requested-With': 'XMLHttpRequest',
            'ACCESS-TOKEN': user.access_token
        }
    }
    _ajaxNoLoading(url, 'post', header, data, _callback, _error);
}

function _ajaxNoLoading(url, type, headers, data, _callback, _error) {
    $.ajax({
        url: window.serverUrl + url,
        type: type,
        headers: headers,
        data: data,
        async: true,
        timeout: window.ajaxTimeout,
        beforeSend: function(xhr, settings) {
            //_loading();
        },
        complete: function(xhr, status) {
            //api.hideProgress();
            api.refreshHeaderLoadDone();
        },
        success: function(result, status, xhr) {
            if (typeof _callback == "function") {
                _callback(result);
            }
        },
        error: function(xhr, errorType, error) {
            if (_error && typeof _error == "function") {
                _error(errorType);
            } else {
                api.toast({
                    msg: '网络连接失败，请检查！'
                });
            }
            //TODO 如果是401，则记录这次访问的连接，然后弹出提示框跳转登录
        }
    });
}

function _loading(title, text) {
    api.showProgress({
        title: title ? title : '',
        text: text ? text : '',
        modal: true
    });
}

function _close() {
    api.closeWin({});
}

function isInArray(arr, value) {
    for (var i = 0; i < arr.length; i++) {
        if (value === arr[i]) {
            return true;
        }
    }
    return false;
}

function jumpto(uri) {
    if (uri && uri != undefined && uri != 'undefined') {
        if (uri.indexOf('http://') >= 0 || uri.indexOf('https://') >= 0) {
            //使用内置浏览器打开一个网页
            var browser = api.require('webBrowser');
            browser.open({
                titleBar: {
                    bg: '#EEEEEE',
                    textColor: '#666666'
                },
                progress: {
                    color: '#16D2C2'
                },
                url: uri
            });
        } else if (uri.indexOf('widget://') >= 0) {
            var parser = parseURL(uri);
            var winfile = parser.protocol + "://" + parser.host + parser.path;
            //在android会出现////
            var winfile1 = winfile.replace(/\/\/\/\//, '\/\/');
            var winname = parser.file.substring(0, parser.file.indexOf('.'));
            _openWin(winname, winfile1, parser.params);
        } else if (uri.indexOf('function://') >= 0) {
            var method = uri.substring(11);
            eval(method);
        } else {
            var u = uri.split(':');
            if (u.length > 1) {
                _openWin(u[0] + '_win', u[0] + '_win.html', {
                    id: u[1]
                });
            } else {
                _openWin(u[0] + '_win', u[0] + '_win.html');
            }
        }
    }
}

function parseURL(url) {
    var a = document.createElement('a');
    a.href = url;
    return {
        source: url,
        protocol: a.protocol.replace(':', ''),
        host: a.hostname,
        port: a.port,
        query: a.search,
        params: (function() {
            var ret = {},
                seg = a.search.replace(/^\?/, '').split('&'),
                len = seg.length,
                i = 0,
                s;
            for (; i < len; i++) {
                if (!seg[i]) {
                    continue;
                }
                s = seg[i].split('=');
                ret[s[0]] = s[1];
            }
            return ret;
        })(),
        file: (a.pathname.match(/\/([^\/?#]+)$/i) || [, ''])[1],
        hash: a.hash.replace('#', ''),
        path: a.pathname.replace(/^([^\/])/, '/$1'),
        relative: (a.href.match(/tps?:\/\/[^\/]+(.+)/) || [, ''])[1],
        segments: a.pathname.replace(/^\//, '').split('/')
    };
}

function getSearchParams(search) {
    var paramPart = search.substr(1).split('&');
    return paramPart.reduce(function(res, item) {
        parts = item.split('=');
        res[parts[0]] = parts[1];
        return res;
    }, {});
}

function hasPermission(one_per) {
    var perms = new Array();
    if (one_per) {
        perms.push(one_per);
    }
    var rets = api.hasPermission({
        list: perms
    });
    return rets;
}

function reqPermission(one_per, callback) {
    var perms = new Array();
    if (one_per) {
        perms.push(one_per);
    }
    api.requestPermission({
        list: perms,
        code: 100001
    }, function(ret, err) {
        if (callback) {
            callback(ret);
            return;
        }
        //console.log(JSON.stringify(ret));
    });
}

function confirmPer(perm) {
    var has = hasPermission(perm);
    if (!has || !has[0] || !has[0].granted) {
        var name;
        switch (perm) {
            case 'storage':
                name = '存储';
                break;
            case 'microphone':
                name = '麦克风';
                break;
            case 'camera':
                name = '摄像头';
                break;
            case 'location':
                name = '位置信息';
                break;
            default:
                name = '未知权限';
        }
        api.confirm({
            title: '提醒',
            msg: '没有获得 ' + name + " 权限\n是否前往设置？",
            buttons: ['去设置', '取消']
        }, function(ret, err) {
            if (1 == ret.buttonIndex) {
                reqPermission(perm);
            }
        });
        return false;
    }
    return true;
}
